function [imNew,fq] = delaunayInterp(im,del,triIDs,Xi,Yi,X0,Y0)
%UNTITLED3 Summary of this function goes here
%   Detailed explanation goes here

imNew = im;

 x1 = Xi(del.ConnectivityList(triIDs,1));
 x2 = Xi(del.ConnectivityList(triIDs,2));
 x3 = Xi(del.ConnectivityList(triIDs,3));
 y1 = Yi(del.ConnectivityList(triIDs,1));
 y2 = Yi(del.ConnectivityList(triIDs,2));
 y3 = Yi(del.ConnectivityList(triIDs,3));

c1 = (x3.*y2 - x2.*y3 + X0.*(y3-y2) - Y0.*(x3-x2))./((x2-x3).*y1 + (x3-x1).*y2 + (x1-x2).*y3);
c2 = (x1.*y3 - x3.*y1 + X0.*(y1-y3) - Y0.*(x1-x3))./((x2-x3).*y1 + (x3-x1).*y2 + (x1-x2).*y3);
c3 = (x2.*y1 - x1.*y2 + X0.*(y2-y1) - Y0.*(x2-x1))./((x2-x3).*y1 + (x3-x1).*y2 + (x1-x2).*y3);

f1 = zeros(length(x1),1);
f2 = zeros(length(x1),1);
f3 = zeros(length(x1),1);

for i = 1:length(x1)
    f1(i) = im(x1(i),y1(i));
    f2(i) = im(x2(i),y2(i));
    f3(i) = im(x3(i),y3(i));
end

fq = c1.*f1 + c2.*f2 + c3.*f3;

for i = 1:length(x1)
    imNew(X0(i),Y0(i)) = fq(i);
end

pts = [X0,Y0];

end

