function imNew = interpolateImage(im)

thresh = 0;

%% 1) identify pixels w/data
[Xi,Yi] = find(im > thresh);

%% 3) blank pixels
[X0,Y0] = find(im <= thresh);
 Xb = find(X0 == 1 | X0 ==size(im,1));
 Yb = find(Y0 == 1 | Y0 ==size(im,2));
 X0(Xb) = -1;
 X0(Yb) = -1;
 Y0(Xb) = -1;
 Y0(Yb) = -1;
 X0n = X0(find(X0 ~= -1));
 Y0n = Y0(find(Y0 ~= -1));
 pts = [X0n,Y0n]; 

%% 2) Delaunay triangulation
del = delaunayTriangulation(Xi,Yi);
% figure();
% trimesh(del,Xi,Yi);

%% 4) Do interpolation
triIDs = pointLocation(del,pts);    % Get triangle indexes for each point

A = find(isnan(triIDs));            % Eliminate Points where triangle not found
triIDs(A) = [];
X0n(A) = [];
Y0n(A) = [];

imNew = delaunayInterp(im,del,triIDs,Xi,Yi,X0n,Y0n);    % Perform interpolation to fill in points without data.  

end

